//a_geno.nss
//Script Pertaining to everything GenoHaradan related.

void main() {

object oPC=GetFirstPC();
object oDessicus=GetObjectByTag("n_dessicus");
effect efVisual=EffectVisualEffect(3003);
object oZez=GetObjectByTag("zez");

int nParam=GetScriptParameter(1);

if (nParam == 0) {
	
	ChangeToStandardFaction(oDessicus, 1);
	object oGeno=GetObjectByTag("geno_disc");

	int nID=0;

	while(GetIsObjectValid(oGeno)) {

		ChangeToStandardFaction(oGeno, 1);
		oGeno=GetObjectByTag("geno_disc", ++nID);
		}
	}

if (nParam == 1) {

	//Dessicus has been driven to half health

	location lDessicus=Location(Vector(15.09, 52.23, 8.64), 270.0);
	location lPC=Location(Vector(15.09, 46.56, 8.64), 180.0);

	AssignCommand(oPC, ActionJumpToLocation(lPC));
	AssignCommand(oDessicus, ActionJumpToLocation(lDessicus));

	int nID=0;
	object oGeno=GetObjectByTag("geno_disc");
	while(GetIsObjectValid(oGeno)) {

		DestroyObject(oGeno);
		oGeno=GetObjectByTag("geno_disc", ++nID);
		}
	}
	
if (nParam == 2) {

//Dessicus taps his wrists and opens doors

	AssignCommand(oDessicus, ActionPlayAnimation(115, 1.0, 3.0));

	DelayCommand(2.5, SetDialogPlaceableCamera(2));

	object oDoor=GetObjectByTag("door_geno", 0);
	object oDoor2=GetObjectByTag("door_geno", 1);

	DelayCommand(3.0, AssignCommand(oDoor, ActionOpenDoor(oDoor)));
	DelayCommand(3.0, AssignCommand(oDoor2, ActionOpenDoor(oDoor2)));
	}

if (nParam == 3) {

	ChangeToStandardFaction(oDessicus, 1);
	location location1=Location(Vector(15.09, 55.17, 8.64), 270.0);

	object oGeno1=GetObjectByTag("c_drexl", 0);
	object oGeno2=GetObjectByTag("c_drexl", 1);

	AssignCommand(oGeno1, ActionForceMoveToLocation(location1, 1));
	AssignCommand(oGeno2, ActionForceMoveToLocation(location1, 1));

	DelayCommand(2.0, AssignCommand(oGeno1, ClearAllActions()));
	DelayCommand(2.0, AssignCommand(oGeno2, ClearAllActions()));

	DelayCommand(2.5, AssignCommand(oGeno1, SetFacingPoint(GetPosition(oPC))));
	DelayCommand(2.5, AssignCommand(oGeno2, SetFacingPoint(GetPosition(oPC))));

	DelayCommand(3.5, ChangeToStandardFaction(oGeno1, 1));
	DelayCommand(3.5, ChangeToStandardFaction(oGeno2, 1));
	}

if (nParam == 4) {

	//Dessicus has been driven down to one hit point, death sequence time

	location lDessicus=Location(Vector(15.09, 52.23, 8.64), 270.0);
	location lPC=Location(Vector(15.09, 46.56, 8.64), 180.0);

	AssignCommand(oPC, ActionJumpToLocation(lPC));
	AssignCommand(oDessicus, ActionJumpToLocation(lDessicus));

	int nID=0;
	object oGeno=GetObjectByTag("geno_elite");
	while(GetIsObjectValid(oGeno)) {

		DestroyObject(oGeno);
		oGeno=GetObjectByTag("geno_elite", ++nID);
		}
	}

if (nParam == 5) {



	location lPC=GetLocation(oPC);
	location lDessicus=GetLocation(oDessicus);

	object oDoor=GetObjectByTag("door_geno", 0);
	object oDoor2=GetObjectByTag("door_geno", 1);
	location lDoor1=GetLocation(oDoor);
	location lDoor2=GetLocation(oDoor2);

	ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lDessicus, 0.0);
	DelayCommand(0.5, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lDoor1, 0.0));
	DelayCommand(1.5, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lDoor2, 0.0));
	DelayCommand(2.0, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lDessicus, 0.0));
	DelayCommand(3.0, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lDoor1, 0.0));
	DelayCommand(3.5, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lDoor2, 0.0));
	DelayCommand(4.0, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lDessicus, 0.0));
	DelayCommand(4.5, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lPC, 0.0));
	DelayCommand(5.5, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lPC, 0.0));
	DelayCommand(6.0, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, lPC, 0.0));
	}

if (nParam == 6) {
	CreateObject(OBJECT_TYPE_CREATURE, "300_sion", Location(Vector(-8.79, 3.12, 8.64), 90.0));
	}

if (nParam == 7) {

	SetGlobalFadeIn(0.0, 3.0);
	object oSion=GetObjectByTag("300_sion");
	location lLoc=Location(Vector(-8.78,11.26, 8.64), 90.0);
	AssignCommand(oSion, ActionForceMoveToLocation(lLoc, FALSE));

	location l1=Location(Vector(-8.26,20.43,8.64), 0.0);
	location l2=Location(Vector(-0.28,20.43,8.64), 0.0);
	location l3=Location(Vector(-1.96,20.43,8.64), 0.0);

	ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, l1, 0.0);
	DelayCommand(1.5, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, l2, 0.0));
	DelayCommand(2.0, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, l3, 0.0));
	DelayCommand(2.5, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, l1, 0.0));
	DelayCommand(3.0, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, l2, 0.0));
	DelayCommand(3.5, ApplyEffectAtLocation(DURATION_TYPE_TEMPORARY, efVisual, l3, 0.0));

	location l5=Location(Vector(36.46,35.34,8.64), 0.00);
	location l6=Location(Vector(34.13,35.34,8.64), 359.50);

	AssignCommand(oPC, JumpToLocation(l5));
	AssignCommand(oZez, JumpToLocation(l6));
	}

if (nParam == 8) {
	SetGlobalBoolean("000_GenoComplete", TRUE);
	StartNewModule("015EBO");
	}
}